
from TwistedHub import *
from numpy.oldnumeric import *
from numpy.core.numerictypes import *
import numpy
from Multipack import *
from numpy.oldnumeric.mlab import *
from basics import *
from FITS import *
import os
from PhotoZ import *
import masks
from pgplot import *
from Mestimators import *
from scipy.special import *
import sys

from LDPGridModels import ldp_import, SEDBases, GalaxyBases

PID = os.getpid()
QueryModule = "/tmp/hubquery%d.py" % (PID)

if os.path.exists("Galaxy8.py"): TEMPLATES = "Galaxy8",
elif os.path.exists("Galaxy7.py"): TEMPLATES = "Galaxy7",
elif os.path.exists("Galaxy6.py"): TEMPLATES = "Galaxy6",
elif os.path.exists("Galaxy5.py"): TEMPLATES = "Galaxy5",
elif os.path.exists("Galaxy4.py"): TEMPLATES = "Galaxy4",
elif os.path.exists("Galaxy3.py"): TEMPLATES = "Galaxy3",
elif os.path.exists("Galaxy2.py"): TEMPLATES = "Galaxy2",
elif os.path.exists("Galaxy.py"): TEMPLATES = "Galaxy",

global rglobals
rglobals = {}
#rglobals['_getattr_'] = Eval.default_guarded_getattr
#rglobals['_getitem_'] = Eval.default_guarded_getitem
def getitem(ob,index): return ob[index]
rglobals['_getattr_'] = getattr
rglobals['_getitem_'] = getitem
rglobals['_getiter_'] = list
rglobals['sys'] = sys

def SetUpGlobals(rglobals):
   for mods in ['numpy','Multipack','FITS','Mestimators']:
      mod = __import__(mods)
      for comp in dir(mod): 
         rglobals[comp] = getattr(mod,comp)
   mod = getattr(numpy,'oldnumeric')
   for comp in dir(mod):
         rglobals[comp] = getattr(mod,comp)
   mod = getattr(getattr(numpy,'oldnumeric'),'mlab')
   for comp in dir(mod):
         rglobals[comp] = getattr(mod,comp)
   rglobals["divz"] = divz
   rglobals["median"] = median
   rglobals["readtable"] = readtable
   rglobals["cosmomod"] = cosmomod
   rglobals["tlook"] = tlook
   rglobals["zlook"] = zlook
   rglobals["mod2mpc"] = mod2mpc
   rglobals["angsize"] = angsize
   rglobals["diff"] = diff
   rglobals["exp"] = exp
   rglobals["exp10"] = exp10
   rglobals["getlog10"] = getlog10
   rglobals["ndtr"] = ndtr
   rglobals["getexp"] = getexp
   rglobals["between"] = between
   rglobals["CMPMPC"] = CMPMPC
   rglobals["CLIGHT"] = CLIGHT
   rglobals["pi"] = pi
   rglobals["polynom"] = polynom
   rglobals["open"] = open
   rglobals["eval"] = eval
   rglobals["stdout"] = sys.stdout
   return rglobals

rglobals = SetUpGlobals(rglobals)

def ObjectFit(lfile,item,key=None,template="Galaxy"):
    if hasattr(rglobals[template],"uap2"):
       hdus = {"Mest1":3,"Mest2":5,"gsols":1,"gsole":2,"gsolm":4,1:1,2:2,3:3}
    else:
       hdus = {"Mest1":3,"Mest2":4,"gsols":1,"gsole":2,"gsolm":-99,1:1,2:2,3:3}
    F = FITS(lfile)
    nh = F.numhdus()[1]
    hdu = hdus[item]
    if hdu == -99:
       return -99
    elif hdu <= nh:
       F.goto(hdu)
       if key: data = F[key]
       else:
          data = F.data()
          if isinstance(item,StringType) and item[:4] == "Mest":
             m = {}
             [m.setdefault(F["mest%d" % (k)].strip(),data[k]) for k in range(len(data))]
             data = m
    else:
       data = None
    F.close()
    return data

def Mestimator(M,j,lfile,template):
    Mest = ObjectFit(lfile,"Mest"+str(j),template=template)[M]
    return Mest

def GetTemplate(template):
    if template not in rglobals:
       ldp_import(template, namespace=rglobals)
#    twisted_import(template)
#    fo,pn,desc = imp.find_module(template)
#    rglobals[template] = IMPORTS[pn][0]

def SetupNamespace(query):
#    rglobals["Template"] = TEMPLATES[0]
    qlines = query.split("\n")
    timport = False
    for ql in qlines:
       ql = ql.replace(" ","").strip()
       if not find(ql,"Template="):
         exec ql in rglobals
         print rglobals["Template"],
         print rglobals["Template"] in rglobals
         if rglobals["Template"] not in rglobals:
            GetTemplate(rglobals["Template"])
         print rglobals["Template"],
         print rglobals["Template"] in rglobals
#         template = rglobals["Template"]
#         twisted_import(template)
#         fo,pn,desc = imp.find_module(template)
#         rglobals[template] = IMPORTS[pn][0]
         timport = True
         break
    if not timport:
       rglobals["Template"] = TEMPLATES[0]
       GetTemplate(rglobals["Template"])
#       template = rglobals["Template"]
#       twisted_import(template)
#       fo,pn,desc = imp.find_module(template)
#       rglobals[template] = IMPORTS[pn][0]
    if os.path.exists(QueryModule):
       f = open(QueryModule,"r")
       old = f.read()
       f.close()
    else:
       old = None
    if query != old:
       if "Prob3d" in rglobals: del rglobals["Prob3d"]
       if "Priors3d" in rglobals: del rglobals["Priors3d"]
       if "Extras" in rglobals: del rglobals["Extras"]
       f = open(QueryModule,"w")
       f.write(query)
       f.close()
       execfile(QueryModule,rglobals)
    print
#    ldict = {}
#    for key in rglobals:
#      ldict[key] = rglobals[key]
#    return ldict

def ObjectCompute(obj,smf,lfile,info,photdata,ndict,verb=0,zpeaks=False):
    if type(ndict) == StringType:
       SetupNamespace(ndict)
       ldict = rglobals
    else:
       ldict = ndict
    template = ldict["Template"]
    print template
    info["tfile"] = os.stat(lfile)[8]
    info["obj"] = obj
    info["smf"] = smf
    if hasattr(ldict[template],"ffix"):
       ffix = ldict[template].ffix
       fform = ldict[template].fform
    else:
       ffix =  None
       fform = None
    F = FITS(lfile)
    numhdus = F.numhdus()[1]
    wf1 = F["lam1"]
    wf2 = F["lam2"]
    msols = []
    while F["qf%d" % (len(msols))] != "N/A":
       msols.append(F["qf%d" % (len(msols))])
    if not len(msols): msols = array([1.0,0.0,0.0])
    if ffix!=None: msols = asarray(msols)[:ffix+1]
    else: msols = [1.0]
    F.close()
    info["wf1"] = wf1
    info["wf2"] = wf2
    if verb: print obj,smf
    ldict["ra"] = info["ra"]
    ldict["dec"] = info["dec"]
    ldict["Phot"] = lambda obj: photdata
    if numhdus == 3 and photdata:
       ldict["Mest1"] = lambda obj,M: ObjectFit(lfile,1,template=template)
       ldict["gsols"] = lambda obj: ObjectFit(lfile,2,template=template)
       ldict["gsole"] = lambda obj: 0*ObjectFit(lfile,2,template=template)
       ldict["gsolm"] = lambda obj: 1+0.0*ObjectFit(lfile,2,template=template)
       ldict["msols"] = lambda obj: ObjectFit(lfile,3,template=template)
       ldict["Mest"] = lambda obj,M: ldict["Mest1"](obj,M)
       print "Using old style."
    else:
       ldict["Mest1"] = lambda obj,M: Mestimator(M,1,lfile,template=template)
       ldict["Mest2"] = lambda obj,M: Mestimator(M,2,lfile,template=template)
       if photdata: ldict["Mest"] = lambda obj,M: ldict["Mest1"](obj,M) + ldict["Mest2"](obj,M)
       else: ldict["Mest"] = lambda obj,M: ldict["Mest1"](obj,M)
       ldict["gsols"] = lambda obj: ObjectFit(lfile,"gsols",template=template)
       ldict["gsole"] = lambda obj: ObjectFit(lfile,"gsole",template=template)
       if hasattr(ldict[template],"uap2"):
          ldict["gsolm"] = lambda obj: ObjectFit(lfile,"gsolm",template=template)
    ldict["zpriors3d"] = lambda obj: Compute3DRedshiftPriors(info["ra"],info["dec"])
    elines = ldict[template].elines
    pshape = ldict[template].pshape
    allz3d = ldict[template].allz3d
    allt3d = ldict[template].allt3d
    allm3d = ldict[template].allm3d
    CPdata = ldict[template].CPdata
    BPdata = ldict[template].BPdata
    redshifts = ldict[template].redshifts
    logages = ldict[template].logages
    metals = ldict[template].metals
    dz = ldict[template].dz
    dt = ldict[template].dlogage
    dm = ldict[template].dmetal
    Mest = ldict["Mest"](obj,"L2")
    x2 = 2*Mest
    mx2 = min(x2.ravel())
    dx2 = x2 - mx2
    if "Prob3d" in ldict:
       print "User input Prob3d"
       p = ldict["Prob3d"](obj)
       print p.shape
    elif "Priors" in ldict:
       print "User input Priors"
       p = exp(-0.5*dx2)
       p = p * ldict["Priors"](allz3d,allt3d,allm3d)
       print p.shape
    else:
       print "Default priors"
       p = exp(-0.5*dx2)
       p = p * exp(allt3d-9.0)*ldict[template].zpriors
       print p.shape

    GALAXY = ldict[template]

    print "Post prob!"
#    p = where(between(p,0,1e99),p,0)
    bs = [1+j for j,key in enumerate(elines) if "Burst" in str(key)]
    nes = len([1+j for j,key in enumerate(elines) if type(key) != StringType])
    np = sum(p.ravel())*dt*dz*dm
    print np
    if np: p = p/np
    pmax = argmax(p.ravel())
    print pmax
    info["pmax"] = pmax
    info["lmax"] = p.ravel()[pmax]
    info["zmax"] = allz3d.ravel()[pmax]
    info["tmax"] = allt3d.ravel()[pmax]
    info["mmax"] = allm3d.ravel()[pmax]
    zprob = add.reduce(add.reduce(p*dt*dm,1),0)
#    zout = open("/tmp/zprob_l.dat","w")
#    for j in range(len(zprob)):
#      print >>zout, j,redshifts[j],zprob[j]
#    zout.close()
    tprob = add.reduce(add.reduce(p*dz*dm,2),0)
    mprob = add.reduce(add.reduce(p*dz*dt,2),1)
    info["zprob"] = zprob
    info["zcls"] = ConfidenceLimits(redshifts,zprob,k=1)
    info["tcls"] = ConfidenceLimits(logages,tprob,k=1)
    info["mcls"] = ConfidenceLimits(metals,mprob,k=1)
    if zpeaks:
       info["zpeaks"] = LikelihoodPeaks(redshifts,zprob)
    gsols = ldict["gsols"](obj).astype(float64)
    print gsols.shape
    gsole = ldict["gsole"](obj).astype(float64)
    print gsole.shape
    uap2 = getattr(ldict[template],"uap2",None)
    if photdata:
       if uap2: gsolm = ldict["gsolm"](obj)
       else: gsolm = asarray([ones(allz3d.shape,float64), zeros(allz3d.shape,float64)])
    else: gsolm = []
    mM = cosmomod(redshifts)[NewAxis,NewAxis,::]
    ldist = mod2mpc(mM)*CMPMPC
    mM = mM*ones(allz3d.shape)
    calive = CPdata[::,::,::,0]
    balive = BPdata[::,::,::,0]
    sba = (4*pi*ldist**2)*ones(allz3d.shape)
    pmass = p.ravel()
    umass = 1.0*greater_equal(pmass,max(pmass)/1e24)
    if not sum(umass): umass = ones(pmass.shape)
    ng = [k for k in elines if k in ["AGN","PL"] or not isinstance(k,StringType)]
    ng = len(gsols)-len(ng)
    if numhdus == 3 and photdata:
       msols3d = ldict["msols"](obj)
       umsols = compress(umass,msols3d.ravel())
#       for ec in range(5):
#          gsols[ec] = 1e11*msols3d*gsols[ec]*exp10(0.4*mM)
#       for ec in range(len(gsols))[-3:]:
#          gsols[ec] = msols3d*gsols[ec]*4*pi*ldist**2
    esols = asarray([compress(umass,(gsols[ec]).ravel()) for ec in range(len(gsols))])
    esole = asarray([compress(umass,(gsole[ec]).ravel()) for ec in range(nes)])
    if gsolm!=[]:
       phave = True
       esolm = [compress(umass,gsolm[0].ravel())]
       esolm += [compress(umass,(gsolm[ec]).ravel()) for ec in range(1,len(gsolm))]
    else:
       phave = False
       esolm = [zeros(compress(umass,umass).shape,float32) for ec in range(2)]
    pmass = compress(umass,pmass)
    calive = compress(umass,calive)
    balive = compress(umass,balive)
    umM = compress(umass,mM.ravel())
    sba = compress(umass,sba.ravel())
    gmass = add.reduce(esols[:ng],0)
    gmassa = add.reduce([esols[j]*calive for j in range(bs[0])],0) + \
        add.reduce([esols[j]*balive for j in bs],0)
    if numhdus == 3 and photdata:
       gmass = gmass * exp10(0.4*umM) * 1e11 * umsols
    if uap2 and (numhdus!=3 or photdata): gmass = sum(esolm[1:]) + (esolm[0]+1)*gmass

    mags = reshape(GALAXY.mags,(len(GALAXY.elines)+1,)+GALAXY.pshape+(GALAXY.nfilts,))
    fconv = CLIGHT*1e8/GALAXY.wleffs**2
    fluxes = exp10(-0.4*(mags+GALAXY.conv_AB+48.60))*fconv[NewAxis,NewAxis,NewAxis,NewAxis,::]
    fluxes = between(mags,-90,90)*fluxes

    nfilts = GALAXY.nfilts
    redf = nonzero(GALAXY.redf)[0]
    obsf = nonzero(logical_not(GALAXY.redf))[0]

    obsm = 0
    for m in obsf:
      Vf = add.reduce(gsols*fluxes[::,::,::,::,m],0)
      Vm = -2.5*getlog10(Vf/fconv[m])-48.60-GALAXY.conv_AB[m]
      Vm = where(between(Vm,-90,90),Vm,-99.0)
      Vm = compress(umass,Vm.ravel())
      curve = "obsmag%02d" % (obsm+1)
      info[curve] = ConfidenceLimits(Vm,pmass)
      obsm += 1

    redm = 0
    for m in redf:
      Vf = add.reduce(gsols*fluxes[::,::,::,::,m],0)
      Vm = -2.5*getlog10(Vf/fconv[m])-48.60-GALAXY.conv_AB[m]
      Vm = where(between(Vm,-90,90),Vm,-99.0)
      Vm = compress(umass,Vm.ravel())
      Vm = Vm - umM
      rcurve = "restmag%02d" % (redm+1)
      info[rcurve] = ConfidenceLimits(Vm,pmass)
      redm += 1

    colors = GALAXY.colors
    for m in colors:
      m1,m2 = subtract(GALAXY.colors[m],1)
      Vf1 = add.reduce(gsols*fluxes[::,::,::,::,m1],0)
      Vm1 = -2.5*getlog10(Vf1/fconv[m1])-48.60-GALAXY.conv_AB[m1]
      Vm1 = where(between(Vm1,-90,90),Vm1,-99.0)
      Vm1 = compress(umass,Vm1.ravel())
      Vf2 = add.reduce(gsols*fluxes[::,::,::,::,m2],0)
      Vm2 = -2.5*getlog10(Vf2/fconv[m2])-48.60-GALAXY.conv_AB[m2]
      Vm2 = where(between(Vm2,-90,90),Vm2,-99.0)
      Vm2 = compress(umass,Vm2.ravel())
      color = Vm1-Vm2
      info["rest"+m] = ConfidenceLimits(color,pmass)

    gmass = getlog10(gmass)
    gmassa = getlog10(gmassa)
    if bs:
       bs = bs[0]
       bmass = divz(add.reduce(esols[bs:ng],0),add.reduce(esols[:ng],0))
    else:
       bmass = 0.0*gmass
    for ec,esol in zip(range(len(esols)),esols):
        if ec:
           if type(elines[ec-1]) != StringType:
               multiply(esol,sba,esol)
           elif elines[ec-1] in ["PL"]:
               multiply(esol,sba,esol)
        info["gcls%d" % (ec)] = ConfidenceLimits(esol,pmass,k=1)
    for ec,esol in zip(range(len(esolm)),esolm):
        info["gclm%d" % (ec)] = ConfidenceLimits(esol,pmass,k=1)
    for ec,esol in zip(range(len(esole)),esole):
        multiply(esol,sba,esol)
        info["gcle%d" % (ec)] = ConfidenceLimits(esol,pmass,k=1)
    info["mass"] = ConfidenceLimits(gmass,pmass,k=1)
    info["massa"] = ConfidenceLimits(gmassa,pmass,k=1)
    info["bmass"] = ConfidenceLimits(bmass,pmass,k=1)
    gsols = array([g.ravel()[pmax] for g in gsols])
    gsole = array([g.ravel()[pmax] for g in gsole])
    gsolm = array([g.ravel()[pmax] for g in gsolm])

    info["gsols"] = gsols
    info["gsole"] = gsole
    info["gsolm"] = gsolm
    if numhdus == 3 and photdata:
       info["msols"] = msols3d.ravel()[pmax]
    else:
       info["msols"] = msols

    bases = ldict[template].seds[::,pmax]
    wave = ldict[template].wave
    dwave = ldict[template].dwave
    model = dot(gsols,bases)
    if nes: smodel = dot(gsols[:-nes],bases[:-nes])
    else: smodel = model
    if fform == "w": sfix = dot(msols,polynom(wave/1e4,ffix))
    elif fform == "dw": sfix = dot(msols,polynom(dwave/200,ffix))
    elif fform == "idw": sfix = dot(msols,polynom(divz(200,dwave),ffix))
    elif fform == "iw": sfix = dot(msols,polynom(divz(1e4,wave)-1,ffix))
    else: sfix = ones(wave.shape)
    sfix = sfix*greater(sfix,0)
    if not sfix.any(): sfix = ones(wave.shape)

    sfile = lfile.replace("_"+template,"")
    sfile = sfile.split("/")
    sfile.remove(template)
    sfile = "/".join(sfile)
    F = FITS(sfile)
    w,dw,s,ds,bg = F.data()
    exptime = F["exptime"]
    aperture = F["aperture"]
    specs = []
    while F["norm%d" % (len(specs)+1)] != "N/A":
        specs.append(F["norm%d" % (len(specs)+1)][1:-1].split(","))
    F.close()
    info["specs"] = specs
    info["exptime"] = exptime
    info["aperture"] = aperture
    sq = sfix*s
    dsq = sfix*ds
    if hasattr(ldict[template],"ferr"):
       dsq = sqrt(dsq**2+(getattr(ldict[template],"ferr")*sq)**2)

    atmos = logical_or(greater(w-1.5*dw,7650),less(w+1.5*dw,7650)) * 0 + 1
    u = between(w,wf1,wf2,inc=1)*greater(dsq,0)*not_equal(sq,0)
    u = u*atmos*greater(sq,-3*dsq)
    uw,udw,usq,udsq,umodel,usmodel = compress(u, [ w,dw,sq,dsq,model,smodel], 1)
    uu = between(w,6000.0,8500,inc=1)*greater(dsq,0)*not_equal(sq,0)
    uuw,uudw,uusq,uudsq,uumodel = compress(uu, [ w,dw,sq,dsq,model], 1)
    if len(uusq):
      info["s2n"] = getpct(divz(uusq,uudsq),75)
      info["s2nm"] = getpct(divz(uusq,uudsq),25)
    else:
      info["s2n"] = 0.0
      info["s2nm"] = 0.0
    good1 = greater(usq,udsq)
    good2 = less(udsq,2*median(udsq))
    good = logical_and(good1,good2)
    ngood = sum(good)
    info["ngood"] = ngood
    npoor = sum(less(usq,-1*udsq))
    info["npoor"] = npoor

    uresid = usq-umodel
    usresid = usq-usmodel
    uchi = divz(uresid,udsq)
    uschi = divz(usresid,udsq)
    info["new_ndeg"] = len(usq)-len(gsols)-len(msols)
    info["new_chi2"] = divz(sum(uchi**2) , info["new_ndeg"])
    info["new_chi2s"] = divz(sum(uschi**2) , info["new_ndeg"])
    if len(usq):
       info["L2"] = sum(L2(uchi))
       info["L1"] = sum(L1(uchi))
       info["Lp"] = sum(Lp(uchi))
       info["Tukey"] = sum(Tukey(uchi))
       info["Fair"] = sum(Fair(uchi))
       info["sL2"] = sum(L2(uschi))
       info["sL1"] = sum(L1(uschi))
       info["sLp"] = sum(Lp(uschi))
       info["sTukey"] = sum(Tukey(uschi))
       info["sFair"] = sum(Fair(uschi))
       info["L2phot"] = -99
    else:
       info["L2"] = 0.0
       info["L1"] = 0.0
       info["Lp"] = 0.0
       info["Tukey"] = 0.0
       info["Fair"] = 0.0
       info["sL2"] = 0.0
       info["sL1"] = 0.0
       info["sLp"] = 0.0
       info["sTukey"] = 0.0
       info["sFair"] = 0.0
       info["L2phot"] = -99

    npshape = multiply.reduce(GALAXY.pshape)

    mags = reshape(GALAXY.mags,(len(GALAXY.elines)+1,npshape,GALAXY.nfilts,))
    mags = mags[::,pmax,::]
    fconv = CLIGHT*1e8/GALAXY.wleffs**2
    fluxes = exp10(-0.4*(mags+GALAXY.conv_AB[NewAxis,::]+48.60))*fconv[NewAxis,::]
    fluxes = between(mags,-90,90)*fluxes

    Vf = add.reduce(gsols[::,NewAxis]*fluxes,0)
    Vm = -2.5*getlog10(Vf/fconv)-48.60-GALAXY.conv_AB
    Vm = where(between(Vm,-90,90),Vm,-99.0)
    info["mags"] = Vm

    if numhdus == 3 and photdata:
       Mest = where(between(Mest,0,1e99),Mest,0)
       info["L2ldp"] = Mest.ravel()[pmax]
    else:
       info["L2ldp"] = Mestimator("L2",1,lfile,template).ravel()[pmax]
       if phave: info["L2phot"] = Mestimator("L2",2,lfile,template).ravel()[pmax]

    if "Extras" in ldict:
       info["Extras"] = ldict["Extras"](obj)
       print "Extras",
       print info["Extras"]

    print "Returning results!\n"
    return info

class LocalPriorDataset:
   def __init__(self,table,zprobs):
       self.table = table
       self.zprobs = zprobs
   def read(self):
       print "Now reading",self.table
       data = readtable(self.table,header="# id",tcols=["id","ra","dec","smf"])
       print "Done reading",self.table
       N = len(data["id"])
       did = {}
       [did.setdefault((data["id"][j],data["smf"][j]),j) for j in range(N)]
       print "N=",N
       F = FITS(self.zprobs)
       naxis2 = F["naxis2"]
       h = F.header()
       z2d = F.data()
       F.close()
       hk = {}
       [hk.setdefault(l[:6],j) for j,l in enumerate(h)]
       o = []
       s = []
       for j in range(naxis2):
          o.append( eval(h[hk["O%05d" % (j+1)]].split("=")[-1]).strip())
          s.append( eval(h[hk["S%05d" % (j+1)]].split("=")[-1]).strip())
       oid = {}
       [oid.setdefault((s[j],o[j]),j) for j in range(naxis2)]
#       print did.keys()[:100]
#       print oid.keys()[:100]
       self.zprob = []
       self.zpos = []
       self.zid = []
       print "M=",naxis2
       for j,oi in enumerate(oid.keys()):
          if j and not (j % 100):
             sys.stdout.write(".")
             sys.stdout.flush()
          if oi in did:
             k = did[oi]
             l = oid[oi]
             self.zid.append(oi)
             self.zprob.append(z2d[l])
             ra = masks.hrrad(masks.scanSexagesimal(data["ra"][k]))
             dec = masks.degrad(masks.scanSexagesimal(data["dec"][k]))
             self.zpos.append([ra,dec])
       print "N2=",len(self.zpos)
   def local(self,ra,dec,n):
       if not hasattr(self,"zpos"): self.read()
       ra = masks.hrrad(masks.scanSexagesimal(ra))
       dec = masks.degrad(masks.scanSexagesimal(dec))
       ara,adec = transpose(self.zpos)
       dra, ddec = ra-ara, dec-adec
       dra = dra * cos(dec)
       ds = sqrt(dra**2+ddec**2)
       zp = zeros(self.zprob[0].shape,float64)
       if n:
         o = sort(ds)[n+1]
         r = o*180*60/pi
         a = pi*r**2
         u = nonzero(less_equal(ds,o)*greater(ds,0))
       else:
         o = ds[-1]
         r = o*180*60/pi
         a = pi*r**2
         u = range(len(self.zprob))
       [add(zp,self.zprob[j],zp) for j in u]
       print ra,dec,n,a
       zp = zp/a
       return zp

def Compute3DRedshiftPriors(ra,dec):
    u = masks.scanSexagesimal(ra)*15*pi/180
    v = masks.scanSexagesimal(dec)*pi/180
    u,v = masks.normalcoord(u,v,zpriors3d["cra"],zpriors3d["cdec"],conv=60*180/pi)
    m = int((u-(zpriors3d["ua"][0]-db/2.))/db)
    n = int((v-(zpriors3d["va"][0]-db/2.))/db)
    m = min([max([m,0]),len(zpriors3d["ua"])-1])
    n = min([max([n,0]),len(zpriors3d["va"])-1])
    return zpriors3d["cube"][::,n,m]

def ConfidenceLimits(x,y,k=3,pl=None):
    x,y = take([x,y],argsort(x),1)
    iy = add.accumulate(y)
    if iy[-1]: iy = iy / iy[-1]
    if pl:
       if iy[0] < pl < iy[-1]:
          ty = concatenate([k*[iy[0]],iy,k*[iy[-1]]])
          cs = splev(pl,[ty,x,k])
       else:
          cs = x[clip(searchsorted(iy,pl),0,len(x)-1)]
       return cs
    else:
       ps = [0.025,0.05,0.16,0.5,0.84,0.95,0.975]
       cs = [ConfidenceLimits(x,y,k=k,pl=p) for p in ps]
       m = argmax(y)
       p = x[m]
       return concatenate([[p],cs])

def LikelihoodPeaks(x,y,k=3):
    print "You want peaks?"
    x,y = take([x,y],argsort(x),1)
    x0,x1 = extrema(x)
    dx = diff(x)[0]
    ox = take(x,argsort(y)[::-1])
    t = 2*(len(x)/10)*dx
    my = max(y)
    mx = [ox[0]]
    [mx.append(x1) for x1 in ox \
        if min(abs(subtract(x1,mx))) > 2.5*dx and \
        sum(less(abs(x-x1),t)*y) > (t/(x[-1]-x[0]))*sum(y)]
    cs = array(mx)
    tx = concatenate([k*[x[0]],x,k*[x[-1]]])
    tck = [tx,y,k]
    ps = lambda p: splev(p,tck,der=1)**2
    cs = sort(array([fsolve(ps,p-0.5*dx,xtol=1e-4,factor=0.01) for p in mx]))
    ds = array([ps(p) for p in cs])
#    print cs
#    print ds
#    cs,ds = compress(less(abs(ds),1e-2),[cs,ds],1)
    es = array([splev(c1,tck,der=2) for c1 in cs])
    cs,ds = compress(less(es,0.0),[cs,ds],1)
    cs = (cs/1e-3+0.5).astype(int32)*1e-3
    cs = sort(list(Set(cs)))
    d = exp(-0.5*pow(1.,2))
    qs = []
    sy = sum(y)
    pq = []
    for c1 in cs:
       p1 = splev(c1,tck)
       tck2 = [tx,y-d*p1,k]
       p2 = sproot(tck2,mest=len(tx))
       p2 = compress(between(p2,x0,x1,inc=1),p2)
       if not len(p2): p2 = extrema(x)
       elif len(p2) >= 2:
           p2 = sort(p2)
           op2 = argsort(abs(p2-c1))
           p2n = p2[op2[0]]
           p2d = abs(p2n-c1)
           p2 = c1+multiply([-1,1],p2d)
       elif len(p2) == 1 and p2[0] > c1:
           p2 = [x[0],p2[0]]
       elif len(p2) == 1 and p2[0] < c1:
           p2 = [p2[0],x[-1]]
       elif len(p2) == 1 and p2[0] == c1:
           p2 = [c1-dx,c1+dx]
       q1 = sum(between(x,p2[0],p2[1],inc=1)*y)
       q1 = divz(q1*(x[-1]-x[0]),sy*(p2[1]-p2[0]))
       pq.extend([c1,p2[0],p2[1],q1])
    return pq

rglobals["ConfidenceLimits"] = ConfidenceLimits
rglobals["LikelihoodPeaks"] = LikelihoodPeaks
rglobals["LocalPriorDataset"] = LocalPriorDataset

